<?php defined("SYSPATH") or die("No direct script access.");

class Admin_ImageBlock2_Controller extends Admin_Controller
{
    public function index()
    {
        $view = new Admin_View("admin.html");
        $view->content = new View("admin_imageblock2.html");
        $view->content->form = $this->_get_setting_form();
        $view->content->help = $this->_get_help_form();

        print $view;
    }

    public function save()
    {
        access::verify_csrf();
        module::clear_var("imageblock2", "relative");

        $form = $this->_get_setting_form();
        if ($form->validate()) {
            $rss_type     = $form->g_admin_settings->rss_type->value;
            $transintype  = $form->g_admin_settings->transintype->value;
            $transouttype = $form->g_admin_settings->transouttype->value;
            $delay        = $form->g_admin_settings->delay->value;
            $target       = $form->g_admin_settings->target->value;
            $album_only   = $form->g_admin_settings->albumonly->value;
            $noflash      = $form->g_admin_settings->noflash->value;

            if ($delay == 15)
                module::clear_var("imageblock2", "delay");
            else
                module::set_var("imageblock2", "delay", $delay);

            if ((!$rss_type) or ($rss_type == "default"))
                module::clear_var("imageblock2", "rss_type");
            else
                module::set_var("imageblock2", "rss_type", $rss_type);

            if ((!$transintype) or ($transintype == "Fade"))
                module::clear_var("imageblock2", "transintype");
            else
                module::set_var("imageblock2", "transintype", $transintype);

            if ((!$transouttype) or ($transouttype == "Fade"))
                module::clear_var("imageblock2", "transouttype");
            else
                module::set_var("imageblock2", "transouttype", $transouttype);

            if ($target == "_parent")
                module::clear_var("imageblock2", "target");
            else
                module::set_var("imageblock2", "target", $target);

            if ($album_only)
                module::set_var("imageblock2", "albumonly", TRUE);
            else
                module::clear_var("imageblock2", "albumonly");

            if ($noflash)
                module::set_var("imageblock2", "noflash", TRUE);
            else
                module::clear_var("imageblock2", "noflash");

            message::success("Settings saved.");
            url::redirect("admin/imageblock2");
        }

        $view = new Admin_View("admin.html");
        $view->content = new View("admin_imageblock2.html");
        $view->content->form = $form;
        $view->content->help = $this->_get_help_form();
        print $view;
    }

    private function _get_setting_form()
    {
        $form = new Forge("admin/imageblock2/save", "", "post", array("id" => "g-admin-imageblock2-form"));
        $group = $form->group("g_admin_settings")->label(t("Settings"));
        $group->dropdown("rss_type")
            ->label(t("RSS Type"))
            ->options(array("default" => t("Default (Root Album)"), "latest" => t("Latest"), "relative" => t("Current Album"), "random" => t("Random")))
            ->selected(module::get_var("imageblock2", "rss_type"));
        $group->dropdown("transintype")
            ->label(t("Transition-In Type"))
            ->options(array("Fade" => t("Default (Fade)"), "Blinds" => t("Blinds"), "Fly" => t("Fly"), "Iris" => t("Iris"), "Photo" => t("Photo"), "PixelDissolve" => t("PixelDissolve"), "Rotate" => t("Rotate"), "Squeeze" => t("Squeeze"), "Wipe" => t("Wipe"), "Zoom" => t("Zoom"), "Random" => t("Random")))
            ->selected(module::get_var("imageblock2", "transintype", "Fade"));
        $group->dropdown("transouttype")
            ->label(t("Transition-Out Type"))
            ->options(array("Fade" => t("Default (Fade)"), "Blinds" => t("Blinds"), "Fly" => t("Fly"), "Iris" => t("Iris"), "Photo" => t("Photo"), "PixelDissolve" => t("PixelDissolve"), "Rotate" => t("Rotate"), "Squeeze" => t("Squeeze"), "Wipe" => t("Wipe"), "Zoom" => t("Zoom"), "Random" => t("Random")))
            ->selected(module::get_var("imageblock2", "transouttype", "Fade"));
        $group->input("delay")
            ->label(t("Image Rotation Delay"))
            ->value(module::get_var("imageblock2", "delay", 15));
        $group->input("target")
            ->label(t("Link Target"))
            ->value(module::get_var("imageblock2", "target", "_parent"));
        $group->checkbox("albumonly")
            ->label(t("Show in Albums Only"))
            ->checked(module::get_var("imageblock2", "albumonly"));
        $group->checkbox("noflash")
            ->label(t("Don't use minislideshow flash"))
            ->checked(module::get_var("imageblock2", "noflash"));

        $group->submit("")->value(t("Save"));

        return $form;
    }

    private function _get_help_form()
    {
        $help  = '<fieldset>';
        $help .= '<legend>Help</legend><ul><br />';
        $help .= '<li><b>RSS Type</b> - type of RSS feed used to create a slideshow.
      <li><b>Transition-in Type</b> - Transition in. Default Fade.
      <li><b>Transition-out Type</b> - Transition Out. Default Fade.
      <li><b>Image Rotation Delay</b> - Number in seconds to display a slide. Default 15.
      <li><b>Link Target</b> - specifies the target for all links in the slideshow. Default _parent.
      <li><b>Show in Albums Only</b> - Make block visible only in album pages. Default False.
      <li><b>Don\'t use minislideshow flash</b> - Just generate a simple image html code, don\'t use minislideshow to show this block. Default False.
      ';
        $help .= '</ul></fieldset>';
        return $help;
    }
}
