<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2009 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class ImageBlock2_block_Core
{
    static function get_site_list()
    {
        return array("image_block" => t("Random Image"));
    }

    static function get_block_code($theme)
    {
        $delay = module::get_var("imageblock2", "delay", 15);
        $transintype = module::get_var("imageblock2", "transintype", "Fade");
        $transouttype = module::get_var("imageblock2", "transouttype", "Fade");
        $target = module::get_var("imageblock2", "target", "_parent");
        $noflash = module::get_var("imageblock2", "noflash", false);

        $player_path = url::file("modules/imageblock2/player/minislideshow.swf");
        $player_params = "&shuffle=true&showDropShadow=true&delay=".$delay."&transInType=".$transintype."&transOutType=".$transouttype."&showTitle=bottom&fullscreenIcon=false&showControls=false&roundedMask=true&titleColor=000000&titleBgColor=FFFFFF";
        if ($target != "_parent")
            $player_params .= "&amp;linkTarget=" . $target . ";";

        $rss_type = module::get_var("imageblock2", "rss_type");
        switch ($rss_type) {
            case "latest":
                $rss_path = rss::url("gallery/lastest");
                break;

            case "relative":
                if ($item = $theme->item()) {
                    if (!$item->is_album())
                        $item = $item->parent();
                    $rss_path = rss::url("gallery/album/{$item->id}?random=1");
                }
                else
                    $rss_path = rss::url("tag/tag/{$theme->tag()->id}");
                break;

            case "default":
            default:
                $rss_path = rss::url("gallery/album/1?random=1");
                break;
        }
	#$rss_path = url::abs_site($rss_path);

        $noFlashContent = false;
        if ($album = $theme->item()) {
            if ($rss_type == "relative") {
                if (!$album->is_album())
                    $album = $album->parent();
                $item = item::random_query()
                    ->where("type", "<>", "album")
                    ->where("left_ptr", ">=", $album->left_ptr)
                    ->where("right_ptr", "<=", $album->right_ptr)
                    ->order_by("rand_key", "DESC")
                    ->find_all(1)->current();
                if (!is_object($item)) {
                    $item = item::random_query()
                        ->where("type", "<>", "album")
                        ->order_by("rand_key", "DESC")
                        ->find_all(1)->current();
                }
            }
            else {
                $item = item::random_query()
                    ->where("type", "<>", "album")
                    ->order_by("rand_key", "DESC")
                    ->find_all(1)->current();
            }
            if (is_object($item)) {
                $link_url = url::file($item->relative_url());
                $img_title = $item->title;
                $thumb_url = $item->thumb_url(false);
                $noFlashContent = "<a href=\"$link_url\" title=\"$img_title\">\n";
                $noFlashContent .= "<img src=\"$thumb_url\" style=\"border: thin solid black;\" alt=\"$img_title\" />\n";
                $noFlashContent .= "</a>\n";
                $noFlashContent .= "<h3>$img_title</h3>\n";
            }
        }
        if ($noFlashContent === false) {
            if ($noflash === false) {
                $noFlashContent = "  <a href=\"http://www.adobe.com/go/getflashplayer\">\n";
                $noFlashContent .= "    <img src=\"http://www.adobe.com/images/shared/download_buttons/get_flash_player.gif\" alt=\"Get Adobe Flash player\" />\n";
                $noFlashContent .= "  </a>\n";
            }
        }

        $js_path = url::file("lib/swfobject.js");
	$width = module::get_var("gallery", "thumb_size");
	$height = $width;

        $content  = "<script type=\"text/javascript\" src=\"$js_path\"></script>\n";
        $content .= "<script type=\"text/javascript\">\n";
        $content .= "  swfobject.registerObject(\"minislideshow\", \"9.0.0\");\n";
        $content .= "</script>\n";
        // for IE here
        $content .= "<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" width=\"$width\" height=\"$height\" id=\"minislideshow\">\n";
        $content .= "  <param name=\"movie\" value=\"$player_path\" />\n";
        $content .= "  <param name=\"flashvars\" value=\"xmlUrl=$rss_path$player_params\" />\n";
        $content .= "  <param name=\"allowScriptAccess\" value=\"always\" />\n";
        $content .= "  <param name=\"wmode\" value=\"transparent\" />\n";
        $content .= "  <param name=\"play\" value=\"false\" />\n";
        $content .= "  <param name=\"menu\" value=\"false\" />\n";
        $content .= "  <param name=\"quality\" value=\"best\" />\n";
        $content .= "  <object type=\"application/x-shockwave-flash\" data=\"$player_path\" width=\"$width\" height=\"$height\">\n";
        $content .= "    <param name=\"flashvars\" value=\"xmlUrl=$rss_path$player_params\" />\n";
        $content .= "    <param name=\"allowScriptAccess\" value=\"always\" />\n";
        $content .= "    <param name=\"wmode\" value=\"transparent\" />\n";
        $content .= "    <param name=\"play\" value=\"false\" />\n";
        $content .= "    <param name=\"menu\" value=\"false\" />\n";
        $content .= "    <param name=\"quality\" value=\"best\" />\n";
        $content .= "    <param name=\"allowFullScreen\" value=\"false\" />\n";
        $content .= $noFlashContent;
        $content .= "  </object>\n";
        $content .= "</object>\n";

        if ($noflash) return $noFlashContent;
        return $content;
    }

    static function get($block_id, $theme)
    {
        $block = "";
        switch ($block_id) {
            case "image_block":
                if ((module::get_var("imageblock2", "rss_type") == "relative") and (!$theme->item()))  // should not be used in non-item related pages
                    break;
                if ((module::get_var("imageblock2", "albumonly")) and ($theme->page_type != "collection"))
                    break;

                $block = new Block();
                $block->css_id = "g-image-block-2";
                $block->title = t("Random image");
                $block->content = new View("imageblock2_block.html");
                $block->content->player = self::get_block_code($theme);
                break;
        }

        return $block;
    }
}

?>
